Index: src/molecules.cpp
===================================================================
--- src/molecules.cpp	(revision 8c54a3b5f6bdf770309a91dff75fb62f47d91b6d)
+++ src/molecules.cpp	(revision 0dbddc24a89f547aa564634e7647f87ec8ce9700)
@@ -3889,146 +4748,146 @@
 int molecule::PowerSetGenerator(ofstream *out, int Order, struct UniqueFragments &FragmentSearch, KeySet RestrictedKeySet)
 {
-	int SP, AtomKeyNr;
-	atom *Walker = NULL, *OtherWalker = NULL, *Predecessor = NULL;
-	bond *Binder = NULL;
-	bond *CurrentEdge = NULL;
-	bond **BondsList = NULL;
-	int RootKeyNr = FragmentSearch.Root->GetTrueFather()->nr;
-	int Counter = FragmentSearch.FragmentCounter;
-	int RemainingWalkers;
-
-	*out << endl;
-	*out << Verbose(0) << "Begin of PowerSetGenerator with order " << Order << " at Root " << *FragmentSearch.Root << "." << endl;
-
-	// prepare Label and SP arrays of the BFS search
-	FragmentSearch.ShortestPathList[FragmentSearch.Root->nr] = 0;
-
-	// prepare root level (SP = 0) and a loop bond denoting Root
-	for (int i=1;i<Order;i++)
-		FragmentSearch.BondsPerSPCount[i] = 0;
-	FragmentSearch.BondsPerSPCount[0] = 1;
-	Binder = new bond(FragmentSearch.Root, FragmentSearch.Root);
-	add(Binder, FragmentSearch.BondsPerSPList[1]);
-
-	// do a BFS search to fill the SP lists and label the found vertices
-	// Actually, we should construct a spanning tree vom the root atom and select all edges therefrom and put them into
-	// according shortest path lists. However, we don't. Rather we fill these lists right away, as they do form a spanning
-	// tree already sorted into various SP levels. That's why we just do loops over the depth (CurrentSP) and breadth
-	// (EdgeinSPLevel) of this tree ...
-	// In another picture, the bonds always contain a direction by rightatom being the one more distant from root and hence
-	// naturally leftatom forming its predecessor, preventing the BFS"seeker" from continuing in the wrong direction.
-	*out << endl;
-	*out << Verbose(0) << "Starting BFS analysis ..." << endl;
-	for (SP = 0; SP < (Order-1); SP++) {
-		*out << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with " << FragmentSearch.BondsPerSPCount[SP] << " item(s)";
-		if (SP > 0) {
-			*out << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl;
-			FragmentSearch.BondsPerSPCount[SP] = 0;
-		} else
-			*out << "." << endl;
-
-		RemainingWalkers = FragmentSearch.BondsPerSPCount[SP];
-		CurrentEdge = FragmentSearch.BondsPerSPList[2*SP];		/// start of this SP level's list
-		while (CurrentEdge->next != FragmentSearch.BondsPerSPList[2*SP+1]) {		/// end of this SP level's list
-			CurrentEdge = CurrentEdge->next;
-			RemainingWalkers--;
-			Walker = CurrentEdge->rightatom;		// rightatom is always the one more distant
-			Predecessor = CurrentEdge->leftatom;		// ... and leftatom is predecessor
-			AtomKeyNr = Walker->nr;
-			*out << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and SP of " << SP << ", with " << RemainingWalkers << " remaining walkers on this level." << endl;
-			// check for new sp level
-			// go through all its bonds
-			*out << Verbose(1) << "Going through all bonds of Walker." << endl;
-			for (int i=0;i<NumberOfBondsPerAtom[AtomKeyNr];i++) {
-				Binder = ListOfBondsPerAtom[AtomKeyNr][i];
-				OtherWalker = Binder->GetOtherAtom(Walker);
-				if ((RestrictedKeySet.find(OtherWalker->nr) != RestrictedKeySet.end())
-	#ifdef ADDHYDROGEN
-				 && (OtherWalker->type->Z != 1)
-	#endif
-																															) {	// skip hydrogens and restrict to fragment
-					*out << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *Binder << "." << endl;
-					// set the label if not set (and push on root stack as well)
-					if ((OtherWalker != Predecessor) && (OtherWalker->GetTrueFather()->nr > RootKeyNr)) { // only pass through those with label bigger than Root's
-						FragmentSearch.ShortestPathList[OtherWalker->nr] = SP+1;
-						*out << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl;
-						// add the bond in between to the SP list
-						Binder = new bond(Walker, OtherWalker); // create a new bond in such a manner, that bond::rightatom is always the one more distant
-						add(Binder, FragmentSearch.BondsPerSPList[2*(SP+1)+1]);
-						FragmentSearch.BondsPerSPCount[SP+1]++;
-						*out << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP+1] << " item(s)." << endl;
-					} else {
-						if (OtherWalker != Predecessor)
-							*out << Verbose(3) << "Not passing on, as index of " << *OtherWalker << " " << OtherWalker->GetTrueFather()->nr << " is smaller than that of Root " << RootKeyNr << "." << endl;
-						else
-							*out << Verbose(3) << "This is my predecessor " << *Predecessor << "." << endl;
-					}
-				} else *out << Verbose(2) << "Is not in the restricted keyset or skipping hydrogen " << *OtherWalker << "." << endl;
-			}
-		}
-	}
-
-	// outputting all list for debugging
-	*out << Verbose(0) << "Printing all found lists." << endl;
-	for(int i=1;i<Order;i++) {		// skip the root edge in the printing
-		Binder = FragmentSearch.BondsPerSPList[2*i];
-		*out << Verbose(1) << "Current SP level is " << i << "." << endl;
-		while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
-			Binder = Binder->next;
-			*out << Verbose(2) << *Binder << endl;
-		}
-	}
-
-	// creating fragments with the found edge sets	(may be done in reverse order, faster)
-	SP = -1;	// the Root <-> Root edge must be subtracted!
-	for(int i=Order;i--;) { // sum up all found edges
-		Binder = FragmentSearch.BondsPerSPList[2*i];
-		while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
-			Binder = Binder->next;
-			SP ++;
-		}
-	}
-	*out << Verbose(0) << "Total number of edges is " << SP << "." << endl;
-	if (SP >= (Order-1)) {
-		// start with root (push on fragment stack)
-		*out << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << ", local nr is " << FragmentSearch.Root->nr << "." << endl;
-		FragmentSearch.FragmentSet->clear();
-		*out << Verbose(0) << "Preparing subset for this root and calling generator." << endl;
-		// prepare the subset and call the generator
-		BondsList = (bond **) Malloc(sizeof(bond *)*FragmentSearch.BondsPerSPCount[0], "molecule::PowerSetGenerator: **BondsList");
-		BondsList[0] = FragmentSearch.BondsPerSPList[0]->next;	// on SP level 0 there's only the root bond
-
-		SPFragmentGenerator(out, &FragmentSearch, 0, BondsList, FragmentSearch.BondsPerSPCount[0], Order);
-
-		Free((void **)&BondsList, "molecule::PowerSetGenerator: **BondsList");
-	} else {
-		*out << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl;
-	}
-
-	// as FragmentSearch structure is used only once, we don't have to clean it anymore
-	// remove root from stack
-	*out << Verbose(0) << "Removing root again from stack." << endl;
-	FragmentSearch.FragmentSet->erase(FragmentSearch.Root->nr);
-
-	// free'ing the bonds lists
-	*out << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl;
-	for(int i=Order;i--;) {
-		*out << Verbose(1) << "Current SP level is " << i << ": ";
-		Binder = FragmentSearch.BondsPerSPList[2*i];
-		while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
-			Binder = Binder->next;
-			// *out << "Removing atom " << Binder->leftatom->nr << " and " << Binder->rightatom->nr << "." << endl; // make sure numbers are local
-			FragmentSearch.ShortestPathList[Binder->leftatom->nr] = -1;
-			FragmentSearch.ShortestPathList[Binder->rightatom->nr] = -1;
-		}
-		// delete added bonds
-		cleanup(FragmentSearch.BondsPerSPList[2*i], FragmentSearch.BondsPerSPList[2*i+1]);
-		// also start and end node
-		*out << "cleaned." << endl;
-	}
-
-	// return list
-	*out << Verbose(0) << "End of PowerSetGenerator." << endl;
-	return (FragmentSearch.FragmentCounter - Counter);
+  int SP, AtomKeyNr;
+  atom *Walker = NULL, *OtherWalker = NULL, *Predecessor = NULL;
+  bond *Binder = NULL;
+  bond *CurrentEdge = NULL;
+  bond **BondsList = NULL;
+  int RootKeyNr = FragmentSearch.Root->GetTrueFather()->nr;
+  int Counter = FragmentSearch.FragmentCounter;
+  int RemainingWalkers;
+
+  *out << endl;
+  *out << Verbose(0) << "Begin of PowerSetGenerator with order " << Order << " at Root " << *FragmentSearch.Root << "." << endl;
+
+  // prepare Label and SP arrays of the BFS search
+  FragmentSearch.ShortestPathList[FragmentSearch.Root->nr] = 0;
+
+  // prepare root level (SP = 0) and a loop bond denoting Root
+  for (int i=1;i<Order;i++)
+    FragmentSearch.BondsPerSPCount[i] = 0;
+  FragmentSearch.BondsPerSPCount[0] = 1;
+  Binder = new bond(FragmentSearch.Root, FragmentSearch.Root);
+  add(Binder, FragmentSearch.BondsPerSPList[1]);
+
+  // do a BFS search to fill the SP lists and label the found vertices
+  // Actually, we should construct a spanning tree vom the root atom and select all edges therefrom and put them into
+  // according shortest path lists. However, we don't. Rather we fill these lists right away, as they do form a spanning
+  // tree already sorted into various SP levels. That's why we just do loops over the depth (CurrentSP) and breadth
+  // (EdgeinSPLevel) of this tree ...
+  // In another picture, the bonds always contain a direction by rightatom being the one more distant from root and hence
+  // naturally leftatom forming its predecessor, preventing the BFS"seeker" from continuing in the wrong direction.
+  *out << endl;
+  *out << Verbose(0) << "Starting BFS analysis ..." << endl;
+  for (SP = 0; SP < (Order-1); SP++) {
+    *out << Verbose(1) << "New SP level reached: " << SP << ", creating new SP list with " << FragmentSearch.BondsPerSPCount[SP] << " item(s)";
+    if (SP > 0) {
+      *out << ", old level closed with " << FragmentSearch.BondsPerSPCount[SP-1] << " item(s)." << endl;
+      FragmentSearch.BondsPerSPCount[SP] = 0;
+    } else
+      *out << "." << endl;
+
+    RemainingWalkers = FragmentSearch.BondsPerSPCount[SP];
+    CurrentEdge = FragmentSearch.BondsPerSPList[2*SP];    /// start of this SP level's list
+    while (CurrentEdge->next != FragmentSearch.BondsPerSPList[2*SP+1]) {    /// end of this SP level's list
+      CurrentEdge = CurrentEdge->next;
+      RemainingWalkers--;
+      Walker = CurrentEdge->rightatom;    // rightatom is always the one more distant
+      Predecessor = CurrentEdge->leftatom;    // ... and leftatom is predecessor
+      AtomKeyNr = Walker->nr;
+      *out << Verbose(0) << "Current Walker is: " << *Walker << " with nr " << Walker->nr << " and SP of " << SP << ", with " << RemainingWalkers << " remaining walkers on this level." << endl;
+      // check for new sp level
+      // go through all its bonds
+      *out << Verbose(1) << "Going through all bonds of Walker." << endl;
+      for (int i=0;i<NumberOfBondsPerAtom[AtomKeyNr];i++) {
+        Binder = ListOfBondsPerAtom[AtomKeyNr][i];
+        OtherWalker = Binder->GetOtherAtom(Walker);
+        if ((RestrictedKeySet.find(OtherWalker->nr) != RestrictedKeySet.end())
+  #ifdef ADDHYDROGEN
+         && (OtherWalker->type->Z != 1)
+  #endif
+                                                              ) {  // skip hydrogens and restrict to fragment
+          *out << Verbose(2) << "Current partner is " << *OtherWalker << " with nr " << OtherWalker->nr << " in bond " << *Binder << "." << endl;
+          // set the label if not set (and push on root stack as well)
+          if ((OtherWalker != Predecessor) && (OtherWalker->GetTrueFather()->nr > RootKeyNr)) { // only pass through those with label bigger than Root's
+            FragmentSearch.ShortestPathList[OtherWalker->nr] = SP+1;
+            *out << Verbose(3) << "Set Shortest Path to " << FragmentSearch.ShortestPathList[OtherWalker->nr] << "." << endl;
+            // add the bond in between to the SP list
+            Binder = new bond(Walker, OtherWalker); // create a new bond in such a manner, that bond::rightatom is always the one more distant
+            add(Binder, FragmentSearch.BondsPerSPList[2*(SP+1)+1]);
+            FragmentSearch.BondsPerSPCount[SP+1]++;
+            *out << Verbose(3) << "Added its bond to SP list, having now " << FragmentSearch.BondsPerSPCount[SP+1] << " item(s)." << endl;
+          } else {
+            if (OtherWalker != Predecessor)
+              *out << Verbose(3) << "Not passing on, as index of " << *OtherWalker << " " << OtherWalker->GetTrueFather()->nr << " is smaller than that of Root " << RootKeyNr << "." << endl;
+            else
+              *out << Verbose(3) << "This is my predecessor " << *Predecessor << "." << endl;
+          }
+        } else *out << Verbose(2) << "Is not in the restricted keyset or skipping hydrogen " << *OtherWalker << "." << endl;
+      }
+    }
+  }
+
+  // outputting all list for debugging
+  *out << Verbose(0) << "Printing all found lists." << endl;
+  for(int i=1;i<Order;i++) {    // skip the root edge in the printing
+    Binder = FragmentSearch.BondsPerSPList[2*i];
+    *out << Verbose(1) << "Current SP level is " << i << "." << endl;
+    while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+      Binder = Binder->next;
+      *out << Verbose(2) << *Binder << endl;
+    }
+  }
+
+  // creating fragments with the found edge sets  (may be done in reverse order, faster)
+  SP = -1;  // the Root <-> Root edge must be subtracted!
+  for(int i=Order;i--;) { // sum up all found edges
+    Binder = FragmentSearch.BondsPerSPList[2*i];
+    while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+      Binder = Binder->next;
+      SP ++;
+    }
+  }
+  *out << Verbose(0) << "Total number of edges is " << SP << "." << endl;
+  if (SP >= (Order-1)) {
+    // start with root (push on fragment stack)
+    *out << Verbose(0) << "Starting fragment generation with " << *FragmentSearch.Root << ", local nr is " << FragmentSearch.Root->nr << "." << endl;
+    FragmentSearch.FragmentSet->clear();
+    *out << Verbose(0) << "Preparing subset for this root and calling generator." << endl;
+    // prepare the subset and call the generator
+    BondsList = (bond **) Malloc(sizeof(bond *)*FragmentSearch.BondsPerSPCount[0], "molecule::PowerSetGenerator: **BondsList");
+    BondsList[0] = FragmentSearch.BondsPerSPList[0]->next;  // on SP level 0 there's only the root bond
+
+    SPFragmentGenerator(out, &FragmentSearch, 0, BondsList, FragmentSearch.BondsPerSPCount[0], Order);
+
+    Free((void **)&BondsList, "molecule::PowerSetGenerator: **BondsList");
+  } else {
+    *out << Verbose(0) << "Not enough total number of edges to build " << Order << "-body fragments." << endl;
+  }
+
+  // as FragmentSearch structure is used only once, we don't have to clean it anymore
+  // remove root from stack
+  *out << Verbose(0) << "Removing root again from stack." << endl;
+  FragmentSearch.FragmentSet->erase(FragmentSearch.Root->nr);
+
+  // free'ing the bonds lists
+  *out << Verbose(0) << "Free'ing all found lists. and resetting index lists" << endl;
+  for(int i=Order;i--;) {
+    *out << Verbose(1) << "Current SP level is " << i << ": ";
+    Binder = FragmentSearch.BondsPerSPList[2*i];
+    while (Binder->next != FragmentSearch.BondsPerSPList[2*i+1]) {
+      Binder = Binder->next;
+      // *out << "Removing atom " << Binder->leftatom->nr << " and " << Binder->rightatom->nr << "." << endl; // make sure numbers are local
+      FragmentSearch.ShortestPathList[Binder->leftatom->nr] = -1;
+      FragmentSearch.ShortestPathList[Binder->rightatom->nr] = -1;
+    }
+    // delete added bonds
+    cleanup(FragmentSearch.BondsPerSPList[2*i], FragmentSearch.BondsPerSPList[2*i+1]);
+    // also start and end node
+    *out << "cleaned." << endl;
+  }
+
+  // return list
+  *out << Verbose(0) << "End of PowerSetGenerator." << endl;
+  return (FragmentSearch.FragmentCounter - Counter);
 };
 
@@ -4041,82 +4900,82 @@
 void molecule::ScanForPeriodicCorrection(ofstream *out)
 {
-	bond *Binder = NULL;
-	bond *OtherBinder = NULL;
-	atom *Walker = NULL;
-	atom *OtherWalker = NULL;
-	double *matrix = ReturnFullMatrixforSymmetric(cell_size);
-	enum Shading *ColorList = NULL;
-	double tmp;
-	Vector Translationvector;
-	//class StackClass<atom *> *CompStack = NULL;
-	class StackClass<atom *> *AtomStack = new StackClass<atom *>(AtomCount);
-	bool flag = true;
-
-	*out << Verbose(2) << "Begin of ScanForPeriodicCorrection." << endl;
-
-	ColorList = (enum Shading *) Malloc(sizeof(enum Shading)*AtomCount, "molecule::ScanForPeriodicCorrection: *ColorList");
-	while (flag) {
-		// remove bonds that are beyond bonddistance
-		for(int i=NDIM;i--;)
-			Translationvector.x[i] = 0.;
-		// scan all bonds
-		Binder = first;
-		flag = false;
-		while ((!flag) && (Binder->next != last)) {
-			Binder = Binder->next;
-			for (int i=NDIM;i--;) {
-				tmp = fabs(Binder->leftatom->x.x[i] - Binder->rightatom->x.x[i]);
-				//*out << Verbose(3) << "Checking " << i << "th distance of " << *Binder->leftatom << " to " << *Binder->rightatom << ": " << tmp << "." << endl;
-				if (tmp > BondDistance) {
-					OtherBinder = Binder->next; // note down binding partner for later re-insertion
-					unlink(Binder);	 // unlink bond
-					*out << Verbose(2) << "Correcting at bond " << *Binder << "." << endl;
-					flag = true;
-					break;
-				}
-			}
-		}
-		if (flag) {
-			// create translation vector from their periodically modified distance
-			for (int i=NDIM;i--;) {
-				tmp = Binder->leftatom->x.x[i] - Binder->rightatom->x.x[i];
-				if (fabs(tmp) > BondDistance)
-					Translationvector.x[i] = (tmp < 0) ? +1. : -1.;
-			}
-			Translationvector.MatrixMultiplication(matrix);
-			//*out << Verbose(3) << "Translation vector is ";
-			Translationvector.Output(out);
-			*out << endl;
-			// apply to all atoms of first component via BFS
-			for (int i=AtomCount;i--;)
-				ColorList[i] = white;
-			AtomStack->Push(Binder->leftatom);
-			while (!AtomStack->IsEmpty()) {
-				Walker = AtomStack->PopFirst();
-				//*out << Verbose (3) << "Current Walker is: " << *Walker << "." << endl;
-				ColorList[Walker->nr] = black;		// mark as explored
-				Walker->x.AddVector(&Translationvector); // translate
-				for (int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {	// go through all binding partners
-					if (ListOfBondsPerAtom[Walker->nr][i] != Binder) {
-						OtherWalker = ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker);
-						if (ColorList[OtherWalker->nr] == white) {
-							AtomStack->Push(OtherWalker); // push if yet unexplored
-						}
-					}
-				}
-			}
-			// re-add bond
-			link(Binder, OtherBinder);
-		} else {
-			*out << Verbose(3) << "No corrections for this fragment." << endl;
-		}
-		//delete(CompStack);
-	}
-
-	// free allocated space from ReturnFullMatrixforSymmetric()
-	delete(AtomStack);
-	Free((void **)&ColorList, "molecule::ScanForPeriodicCorrection: *ColorList");
-	Free((void **)&matrix, "molecule::ScanForPeriodicCorrection: *matrix");
-	*out << Verbose(2) << "End of ScanForPeriodicCorrection." << endl;
+  bond *Binder = NULL;
+  bond *OtherBinder = NULL;
+  atom *Walker = NULL;
+  atom *OtherWalker = NULL;
+  double *matrix = ReturnFullMatrixforSymmetric(cell_size);
+  enum Shading *ColorList = NULL;
+  double tmp;
+  Vector Translationvector;
+  //class StackClass<atom *> *CompStack = NULL;
+  class StackClass<atom *> *AtomStack = new StackClass<atom *>(AtomCount);
+  bool flag = true;
+
+  *out << Verbose(2) << "Begin of ScanForPeriodicCorrection." << endl;
+
+  ColorList = (enum Shading *) Malloc(sizeof(enum Shading)*AtomCount, "molecule::ScanForPeriodicCorrection: *ColorList");
+  while (flag) {
+    // remove bonds that are beyond bonddistance
+    for(int i=NDIM;i--;)
+      Translationvector.x[i] = 0.;
+    // scan all bonds
+    Binder = first;
+    flag = false;
+    while ((!flag) && (Binder->next != last)) {
+      Binder = Binder->next;
+      for (int i=NDIM;i--;) {
+        tmp = fabs(Binder->leftatom->x.x[i] - Binder->rightatom->x.x[i]);
+        //*out << Verbose(3) << "Checking " << i << "th distance of " << *Binder->leftatom << " to " << *Binder->rightatom << ": " << tmp << "." << endl;
+        if (tmp > BondDistance) {
+          OtherBinder = Binder->next; // note down binding partner for later re-insertion
+          unlink(Binder);   // unlink bond
+          *out << Verbose(2) << "Correcting at bond " << *Binder << "." << endl;
+          flag = true;
+          break;
+        }
+      }
+    }
+    if (flag) {
+      // create translation vector from their periodically modified distance
+      for (int i=NDIM;i--;) {
+        tmp = Binder->leftatom->x.x[i] - Binder->rightatom->x.x[i];
+        if (fabs(tmp) > BondDistance)
+          Translationvector.x[i] = (tmp < 0) ? +1. : -1.;
+      }
+      Translationvector.MatrixMultiplication(matrix);
+      //*out << Verbose(3) << "Translation vector is ";
+      Translationvector.Output(out);
+      *out << endl;
+      // apply to all atoms of first component via BFS
+      for (int i=AtomCount;i--;)
+        ColorList[i] = white;
+      AtomStack->Push(Binder->leftatom);
+      while (!AtomStack->IsEmpty()) {
+        Walker = AtomStack->PopFirst();
+        //*out << Verbose (3) << "Current Walker is: " << *Walker << "." << endl;
+        ColorList[Walker->nr] = black;    // mark as explored
+        Walker->x.AddVector(&Translationvector); // translate
+        for (int i=0;i<NumberOfBondsPerAtom[Walker->nr];i++) {  // go through all binding partners
+          if (ListOfBondsPerAtom[Walker->nr][i] != Binder) {
+            OtherWalker = ListOfBondsPerAtom[Walker->nr][i]->GetOtherAtom(Walker);
+            if (ColorList[OtherWalker->nr] == white) {
+              AtomStack->Push(OtherWalker); // push if yet unexplored
+            }
+          }
+        }
+      }
+      // re-add bond
+      link(Binder, OtherBinder);
+    } else {
+      *out << Verbose(3) << "No corrections for this fragment." << endl;
+    }
+    //delete(CompStack);
+  }
+
+  // free allocated space from ReturnFullMatrixforSymmetric()
+  delete(AtomStack);
+  Free((void **)&ColorList, "molecule::ScanForPeriodicCorrection: *ColorList");
+  Free((void **)&matrix, "molecule::ScanForPeriodicCorrection: *matrix");
+  *out << Verbose(2) << "End of ScanForPeriodicCorrection." << endl;
 };
 
@@ -4127,45 +4986,45 @@
 double * molecule::ReturnFullMatrixforSymmetric(double *symm)
 {
-	double *matrix = (double *) Malloc(sizeof(double)*NDIM*NDIM, "molecule::ReturnFullMatrixforSymmetric: *matrix");
-	matrix[0] = symm[0];
-	matrix[1] = symm[1];
-	matrix[2] = symm[3];
-	matrix[3] = symm[1];
-	matrix[4] = symm[2];
-	matrix[5] = symm[4];
-	matrix[6] = symm[3];
-	matrix[7] = symm[4];
-	matrix[8] = symm[5];
-	return matrix;
+  double *matrix = (double *) Malloc(sizeof(double)*NDIM*NDIM, "molecule::ReturnFullMatrixforSymmetric: *matrix");
+  matrix[0] = symm[0];
+  matrix[1] = symm[1];
+  matrix[2] = symm[3];
+  matrix[3] = symm[1];
+  matrix[4] = symm[2];
+  matrix[5] = symm[4];
+  matrix[6] = symm[3];
+  matrix[7] = symm[4];
+  matrix[8] = symm[5];
+  return matrix;
 };
 
 bool KeyCompare::operator() (const KeySet SubgraphA, const KeySet SubgraphB) const
 {
-	//cout << "my check is used." << endl;
-	if (SubgraphA.size() < SubgraphB.size()) {
-		return true;
-	} else {
-		if (SubgraphA.size() > SubgraphB.size()) {
-			return false;
-		} else {
-			KeySet::iterator IteratorA = SubgraphA.begin();
-			KeySet::iterator IteratorB = SubgraphB.begin();
-			while ((IteratorA != SubgraphA.end()) && (IteratorB != SubgraphB.end())) {
-				if ((*IteratorA) <	(*IteratorB))
-					return true;
-				else if ((*IteratorA) > (*IteratorB)) {
-						return false;
-					} // else, go on to next index
-				IteratorA++;
-				IteratorB++;
-			} // end of while loop
-		}// end of check in case of equal sizes
-	}
-	return false; // if we reach this point, they are equal
+  //cout << "my check is used." << endl;
+  if (SubgraphA.size() < SubgraphB.size()) {
+    return true;
+  } else {
+    if (SubgraphA.size() > SubgraphB.size()) {
+      return false;
+    } else {
+      KeySet::iterator IteratorA = SubgraphA.begin();
+      KeySet::iterator IteratorB = SubgraphB.begin();
+      while ((IteratorA != SubgraphA.end()) && (IteratorB != SubgraphB.end())) {
+        if ((*IteratorA) <  (*IteratorB))
+          return true;
+        else if ((*IteratorA) > (*IteratorB)) {
+            return false;
+          } // else, go on to next index
+        IteratorA++;
+        IteratorB++;
+      } // end of while loop
+    }// end of check in case of equal sizes
+  }
+  return false; // if we reach this point, they are equal
 };
 
 //bool operator < (KeySet SubgraphA, KeySet SubgraphB)
 //{
-//	return KeyCompare(SubgraphA, SubgraphB);
+//  return KeyCompare(SubgraphA, SubgraphB);
 //};
 
@@ -4179,23 +5038,23 @@
 inline void InsertFragmentIntoGraph(ofstream *out, struct UniqueFragments *Fragment)
 {
-	GraphTestPair testGraphInsert;
-
-	testGraphInsert = Fragment->Leaflet->insert(GraphPair (*Fragment->FragmentSet,pair<int,double>(Fragment->FragmentCounter,Fragment->TEFactor)));	// store fragment number and current factor
-	if (testGraphInsert.second) {
-		*out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " successfully inserted." << endl;
-		Fragment->FragmentCounter++;
-	} else {
-		*out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
-		((*(testGraphInsert.first)).second).second += Fragment->TEFactor;	// increase the "created" counter
-		*out << Verbose(2) << "New factor is " << ((*(testGraphInsert.first)).second).second << "." << endl;
-	}
+  GraphTestPair testGraphInsert;
+
+  testGraphInsert = Fragment->Leaflet->insert(GraphPair (*Fragment->FragmentSet,pair<int,double>(Fragment->FragmentCounter,Fragment->TEFactor)));  // store fragment number and current factor
+  if (testGraphInsert.second) {
+    *out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " successfully inserted." << endl;
+    Fragment->FragmentCounter++;
+  } else {
+    *out << Verbose(2) << "KeySet " << Fragment->FragmentCounter << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
+    ((*(testGraphInsert.first)).second).second += Fragment->TEFactor;  // increase the "created" counter
+    *out << Verbose(2) << "New factor is " << ((*(testGraphInsert.first)).second).second << "." << endl;
+  }
 };
 //void inline InsertIntoGraph(ofstream *out, KeyStack &stack, Graph &graph, int *counter, double factor)
 //{
-//	// copy stack contents to set and call overloaded function again
-//	KeySet set;
-//	for(KeyStack::iterator runner = stack.begin(); runner != stack.begin(); runner++)
-//		set.insert((*runner));
-//	InsertIntoGraph(out, set, graph, counter, factor);
+//  // copy stack contents to set and call overloaded function again
+//  KeySet set;
+//  for(KeyStack::iterator runner = stack.begin(); runner != stack.begin(); runner++)
+//    set.insert((*runner));
+//  InsertIntoGraph(out, set, graph, counter, factor);
 //};
 
@@ -4208,16 +5067,16 @@
 inline void InsertGraphIntoGraph(ofstream *out, Graph &graph1, Graph &graph2, int *counter)
 {
-	GraphTestPair testGraphInsert;
-
-	for(Graph::iterator runner = graph2.begin(); runner != graph2.end(); runner++) {
-		testGraphInsert = graph1.insert(GraphPair ((*runner).first,pair<int,double>((*counter)++,((*runner).second).second)));	// store fragment number and current factor
-		if (testGraphInsert.second) {
-			*out << Verbose(2) << "KeySet " << (*counter)-1 << " successfully inserted." << endl;
-		} else {
-			*out << Verbose(2) << "KeySet " << (*counter)-1 << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
-			((*(testGraphInsert.first)).second).second += (*runner).second.second;
-			*out << Verbose(2) << "New factor is " << (*(testGraphInsert.first)).second.second << "." << endl;
-		}
-	}
+  GraphTestPair testGraphInsert;
+
+  for(Graph::iterator runner = graph2.begin(); runner != graph2.end(); runner++) {
+    testGraphInsert = graph1.insert(GraphPair ((*runner).first,pair<int,double>((*counter)++,((*runner).second).second)));  // store fragment number and current factor
+    if (testGraphInsert.second) {
+      *out << Verbose(2) << "KeySet " << (*counter)-1 << " successfully inserted." << endl;
+    } else {
+      *out << Verbose(2) << "KeySet " << (*counter)-1 << " failed to insert, present fragment is " << ((*(testGraphInsert.first)).second).first << endl;
+      ((*(testGraphInsert.first)).second).second += (*runner).second.second;
+      *out << Verbose(2) << "New factor is " << (*(testGraphInsert.first)).second.second << "." << endl;
+    }
+  }
 };
 
@@ -4226,9 +5085,9 @@
  * -# constructs a complete keyset of the molecule
  * -# In a loop over all possible roots from the given rootstack
- *	-# increases order of root site
- *	-# calls PowerSetGenerator with this order, the complete keyset and the rootkeynr
- *	-# for all consecutive lower levels PowerSetGenerator is called with the suborder, the higher order keyset
+ *  -# increases order of root site
+ *  -# calls PowerSetGenerator with this order, the complete keyset and the rootkeynr
+ *  -# for all consecutive lower levels PowerSetGenerator is called with the suborder, the higher order keyset
 as the restricted one and each site in the set as the root)
- *	-# these are merged into a fragment list of keysets
+ *  -# these are merged into a fragment list of keysets
  * -# All fragment lists (for all orders, i.e. from all destination fields) are merged into one list for return
  * Important only is that we create all fragments, it is not important if we create them more than once
